package com.andersjbe.mongospringpractice.service;

import com.andersjbe.mongospringpractice.model.Address;
import com.andersjbe.mongospringpractice.model.User;
import com.andersjbe.mongospringpractice.repository.UserRespository;
import com.fasterxml.jackson.databind.ObjectMapper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.HashMap;
import java.util.List;
import java.util.Optional;

@Service
public class UserService {
    @Autowired
    UserRespository respository;

    public List<User> findAllUsers() {
        return respository.findAll();
    }

    public Optional<User> findUserById(String id) {
        return respository.findById(id);
    }

    public User createUser(User user) {
        return respository.save(user);
    }

    public User updateUserById(User fresh, String userId) {
        User stale = findUserById(userId)
                .orElseThrow(() -> new IllegalArgumentException("User does not exist"));
        if (fresh.getAge() != null) stale.setAge(fresh.getAge());
        if (fresh.getFirstName() != null) stale.setFirstName(fresh.getFirstName());
        if (fresh.getLastName() != null) stale.setLastName(fresh.getLastName());
        if (fresh.getAddress() != null) stale.setAddress(fresh.getAddress());
        respository.save(stale);
        return stale;
    }

    public User deleteUser(User user) {
        respository.delete(user);
        return user;
    }
}
